"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_tools_1 = require("graphql-tools");
var graphql_1 = require("graphql");
var makeSqlSchema_1 = require("./makeSqlSchema");
function getSchemaDirectives(_a) {
    var _b;
    var _c = (_a === void 0 ? {} : _a).directiveName, directiveName = _c === void 0 ? 'sql' : _c;
    var SqlDirective = /** @class */ (function (_super) {
        __extends(SqlDirective, _super);
        function SqlDirective() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        SqlDirective.getDirectiveDeclaration = function (name, schema) {
            return new graphql_1.GraphQLDirective({
                name: name,
                locations: [
                    graphql_1.DirectiveLocation.OBJECT,
                    graphql_1.DirectiveLocation.FIELD_DEFINITION,
                ],
                args: {
                    unicode: {
                        type: graphql_1.GraphQLBoolean,
                    },
                    constraints: {
                        type: graphql_1.GraphQLString,
                    },
                    auto: {
                        type: graphql_1.GraphQLBoolean,
                    },
                    default: {
                        type: graphql_1.GraphQLString,
                    },
                    hide: {
                        type: graphql_1.GraphQLBoolean,
                    },
                    index: {
                        type: graphql_1.GraphQLBoolean,
                    },
                    nullable: {
                        type: graphql_1.GraphQLBoolean,
                    },
                    primary: {
                        type: graphql_1.GraphQLBoolean,
                    },
                    type: {
                        type: graphql_1.GraphQLString,
                    },
                    unique: {
                        type: graphql_1.GraphQLBoolean,
                    },
                    generated: {
                        type: graphql_1.GraphQLString,
                    },
                },
            });
        };
        SqlDirective.prototype.visitObject = function (object) {
            var tableName = object.name;
            var sqlTable = __assign({ name: tableName, columns: {} }, this.args);
            makeSqlSchema_1.addTable(sqlTable);
            // console.log('visitObject', tableName, this.args)
        };
        SqlDirective.prototype.visitFieldDefinition = function (field, details) {
            if (!this.args.hide) {
                var tableName = details.objectType.name;
                var columnName = field.name;
                var sqlColumn = __assign({ name: columnName, graphQLType: field.type.toString() }, this.args);
                makeSqlSchema_1.addColumn(tableName, sqlColumn);
            }
            // console.log('visitFieldDefinition', tableName, columnName, this.args)
        };
        return SqlDirective;
    }(graphql_tools_1.SchemaDirectiveVisitor));
    return _b = {},
        _b[directiveName] = SqlDirective,
        _b;
}
exports.getSchemaDirectives = getSchemaDirectives;
// todo handle hide by using Schema Transforms to filter types marked with hide
function customDirectiveDeclaration(customDirectiveName) {
    return "directive @" + customDirectiveName + "(\n    unicode: Boolean\n    auto: Boolean\n    default: String\n    hide: Boolean\n    index: Boolean\n    nullable: Boolean\n    primary: Boolean\n    type: String\n    unique: Boolean\n    generated: String\n  ) on OBJECT | FIELD_DEFINITION";
}
exports.customDirectiveDeclaration = customDirectiveDeclaration;
exports.sqlDirectiveDeclaration = customDirectiveDeclaration('sql');
